<?php
// $Id: common.inc,v 1.1 2006/05/01 00:59:21 amnonj Exp $
/**
 * Insert new fact
 *
 * Insert new fact to Family database.
 *
 * @param $fact_code
 *   A 3-4 characters string containing a valid GEDCOM tag or a user defined tag.
 * A user defined tag must start with underscore.
 * @param $value
 *   The value to be inserted for the new fact. Value format depend on the fact.
 * @return
 *  fid (fact id) of the new fact.
 */
function family_insert_fact($fact_code, $value) {
  $fid = db_next_id('{family_facts}_fid');
  db_query("INSERT INTO {family_facts} (fid, fact_code, fact_value) VALUES (%d, '%s', '%s')", $fid, $fact_code, $value);
  return ($fid);
}

function family_update_fact($fid, $value) {
  return (db_query("UPDATE {family_facts} SET fact_value = '%s' WHERE fid = %d", $value, $fid));
}

function family_remove_fact($fid) {
  //Find and remove each Subfact
  $fids = db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
          "WHERE f.fid=r.fid1 AND r.fid2= %d", $fid);
  while ($sub_fid = db_fetch_array($fids) ) {
    $removed = family_remove_fact($sub_fid, $fid);
  }
  //Remove both the fact & relationship to parent facts
  db_query("DELETE FROM family_relations WHERE fid1 = %d", $fid);
  db_query("DELETE FROM family_facts WHERE fid = %d", $fid);
}

function family_insert_relation($fid1, $fid2, $desc) {
  $rid = db_next_id('{family_relations}_rid');
  db_query("INSERT INTO {family_relations} (rid, fid1, fid2, relation_description) VALUES (%d, %d, %d, '%s')",
    $rid, $fid1, $fid2, $desc);
}

function family_get_subfid_by_code($fact_code, $fid) {
  $subfid = db_result(db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
          "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", $fact_code, $fid));
  return ($subfid);
}

function family_get_subvalue_by_code($fact_code, $fid) {
  $subval = db_result(db_query("SELECT f.fact_value FROM {family_facts} f, {family_relations} r ".
          "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", $fact_code, $fid));
  return ($subval);
}

function family_getfacts($fid)
{
  $personfact = array();
  $person = db_query("SELECT {family_facts}.fid, {family_facts}.fact_code, {family_facts}.fact_value from {family_facts} INNER JOIN {family_relations} ON {family_facts}.fid = {family_relations}.fid1 AND {family_relations}.fid2 = %d", $fid);
  while($attribs = db_fetch_array($person)) {
    $personfact[$attribs['fact_code']]=array('value' => $attribs['fact_value'], 'fid' => $attribs['fid']);
  }
  return $personfact;
}

/**
 * Check if record $fid is private.
 */
function family_check_privacy($fid) {
  if ($privacy_fid = family_get_subfid_by_code("_PRV", $fid)){
    $privacy = family_get_subvalue_by_code("_PRV", $fid);
  }
  else {
    $privacy=0;
  }
  if (($privacy==0) || ($privacy==1) || ($privacy==3)) {
    return user_access('access family');
  } else {
    return user_access('access family private records');
  }
} 


