<?php
// $Id: import.inc,v 1.4 2006/05/01 00:59:21 amnonj Exp $
require_once "includes/common.inc";
// import.inc
// Functions for importing GEDCOM files to database
// Using the data base defined in simple.mysql
// This may also be used as a temporary storage before making more processing
// for import to other database format.

ini_set('auto_detect_line_endings', true);

//Generate a form for uploading a GEDCOM file
function family_import() {
  $content = '<p><strong>Caution: this will delete any current content from family '.
              'database</strong><br><form enctype="multipart/form-data"'.
              'action="/admin/family/import_done" method="POST">'.
              '<input type="hidden" name="MAX_FILE_SIZE" value="100000" >'.
              'Choose a file to upload: <input name="gedcom_file" type="file"><br>'.
              '<input type="submit" value="Upload File"></form></p>';
  return $content;
}

// Parse the uploaded GEDCOM file
function family_import_done() {
  $content="<p>";
  $fp = fopen( $_FILES['gedcom_file']['tmp_name'] , "r" );
  if (!$fp) {
    return "<p>Couldn't open the data file.</p>";
  }

  $gedcom_hier=array();   // References to GEDCOM parents on each level
//Empty current content. This is useful for debugging, but more caution should be
//done before deleting database in the working version
  db_query("TRUNCATE family_facts");
  db_query("TRUNCATE family_relations");

  while (!feof ($fp)) {
    $gedline = fgets( $fp, 1024 );
    if (preg_match("/^\s*(\d+)\s*(?:@([^@]+)@)?\s*(\S+)\s*(.*\S)?\s*$/i", $gedline , $matches)) {

      $level=$matches[1];
      $xref=$matches[2];
      $fact_code=$matches[3];
      $value=$matches[4];
      $gedcom_source=$gedline;
      $parent=$gedcom_hier[$level-1];

      if (strpos(";HUSB;WIFE;CHIL",$fact_code)) {   //Lines that define only a relation
        $gedcom_hier[$level]=NULL;
        preg_match("/@\s*([^@\s]+)\s*@/i", $gedline , $matches);
        $target_xref=$matches[1];
        $fid = db_result(db_query("SELECT fid FROM {family_facts} WHERE xref = '%s'", $target_xref));
        $relation=$fact_code;
      }
      else {           //lines that define a fact
//Add fact, meanwhile every INDI fact gets a node
        $fid = db_next_id('{family_facts}_fid');
        $nid=NULL;
        $relation="FACT";

        if ($fact_code == 'INDI') {
          unset($node);
          $node->type = "family_individual";
          $node->uid = $user->uid;
          $node->title = "Unknown";
          $node->status = 1;
          $node->moderate = 0;
          $node->comment = 2;
          $node->revision = 0;
//          $node->created = mktime($date[0]->hour, $date[0]->minute, $date[0]->second, $date[0]->month, $date[0]->day, $date[0]->year);
//          $node->changed = mktime($date[1]->hour, $date[1]->minute, $date[1]->second, $date[1]->month, $date[1]->day, $date[1]->year);
          $node->fid = $fid;
          $node->xref = $xref;
          $node->value = $value;
          $node->gedcom_source = $gedcom_source;
          node_validate($node, $error);
          if (!node_access("create", $node)) {
            $error['access'] = message_access();
          }
          if ($error) {
            print '<pre>';
            print_r($error);
            print '</pre>';
          }
          else {
            node_save($node);
            $nid=$node->nid;
          }
          unset($node);
        }
        else {

// Add fact that is not a node
          db_query("INSERT INTO {family_facts} (fid, nid, xref, fact_code, fact_value,
                         gedcom_source) VALUES (%d, %d, '%s', '%s', '%s', '%s')", $fid,
                        $nid, $xref,$fact_code,$value,$gedcom_source);
        }
        $gedcom_hier[$level] = $fid;
        $gedcom_source=null; // If the source is in fact table, no need to put it again in relation table
      }

      if ($level>0) {
        $rid = db_next_id('{family_relations}_fid');
        db_query("INSERT INTO {family_relations} (rid, fid1, fid2, relation_description,
                       gedcom_source) VALUES (%d, %d, %d, '%s', '%s')",
                       $rid,$fid, $parent, $relation, $gedcom_source);
      }
    }
  }
  fclose ($fp);
  //Clean it all up
  $fids = db_query("SELECT fid FROM family_facts WHERE fact_code = 'INDI'");
  while ($fid = db_fetch_array($fids)) {
    family_import_cleanup_indinode($fid['fid']);
  }
  $content.="</p>";
//  print theme('page', $content);       //uncomment for drupal 4.6
  return $content;                       //This supports drupal 4.7
}

function family_import_cleanup_indinode($fid) {
  $nid = db_result(db_query("SELECT nid FROM {family_facts} WHERE fid= %d", $fid));
  $vid = db_result(db_query("SELECT vid FROM {node} WHERE nid= %d", $nid));
  //UPDATE NAME
  $name = family_get_subvalue_by_code('NAME', $fid);
  $name=str_replace("/","",$name); //Remove slashes arround surname
  $node=node_load($nid);
  $node->title = $name;
  node_save(&$node);
//  db_query("UPDATE {node} SET title = '%s' WHERE nid = %d", $name, $nid);
  //Update node_revisions - title
//  db_query( "UPDATE {node_revisions} SET title = '%s' WHERE vid = %d",
//             $name, $vid );
}

