<?php
// $Id: view.inc,v 1.3 2006/05/01 00:59:21 amnonj Exp $
function family_make_link($fid, $text) {
  $nid = db_result(db_query("SELECT nid FROM family_facts WHERE fid = %d", $fid));
  $output = "<a href=\"/node/".$nid."\">";
  $output .= $text;
  $output .= "</a>";
  return $output;
}

function family_make_name($fid)
{
  if ($fid) {
    if (family_check_privacy($fid)) {
      $personfact = family_getfacts($fid);
      $name = $personfact['NAME']['value'];
      if ($name) {
        $name = str_replace("/","",$name); //Remove slashes arround surname
      }
      else {
        $name = 'Unknown';
      }
    }
    else {
      return 'Private';
    }
    return family_make_link($fid,$name);
  }
  else {
    return "Error!";
  }
}

function family_indi_list($indilist) {
  $output = '';
  $header = array(
    'Last Name',
    'First Name',
    'Sex',
    'Birth Date',
    'Birth Place',
    'Death Date',
    'Death Place'
  );
  $facts = array();
  if ($indilist=='ALL') {
    $individuals = db_query("SELECT fid FROM {family_facts} WHERE fact_code = 'INDI'");
  }
  else {
    $individuals = $indilist;
  }
  if ($individuals && (db_num_rows($individuals)>0)) {
    for ($i = 0; $i < db_num_rows($individuals); $i++) {
      $fid=db_result($individuals,$i);
      if (family_check_privacy($fid)) {
        $personfact = family_getfacts($fid);
        $name = $personfact['NAME']['value'];
        if ($name) {
          if (preg_match("/^(.*)\/(.*)\/(.*)$/i", $name , $matches)) {
            $surname = $matches[2];
            $firstname = $matches[1].$matches[3];
          }
          $name=str_replace("/","",$name); //Remove slashes arround surname
        }
        else {
          $name="Unknown";
        }
        $birth = $personfact['BIRT'];
        $birthfacts = family_getfacts($birth['fid']);
        $death = $personfact['DEAT'];
        $deathfacts = family_getfacts($death['fid']);
        $facts[$fid] = array(
          'SURN' => family_make_link($fid, $surname),
          'GIVN' => family_make_link($fid, $firstname),
          'SEX' => family_make_link($fid, $personfact['SEX']['value']),
          'BIRTD' => family_make_link($fid, $birthfacts['DATE']['value']),
          'BIRTP' => family_make_link($fid, $birthfacts['PLAC']['value']),
          'DEATD' => family_make_link($fid, $deathfacts['DATE']['value']),
          'DEATP' => family_make_link($fid, $deathfacts['PLAC']['value'])
        );
      }
      elseif ($indilist != 'ALL') {  //Avoid listing all the private in the global listing
        $facts[$fid] = array(
          'SURN' => 'Private',
          'GIVN' => '',
          'SEX' => '',
          'BIRTD' => '',
          'BIRTP' => '',
          'DEATD' => '',
          'DEATP' => ''
        );
      }
    }
  }

  $output .= theme('table', $header, $facts);
  return $output;
}

// Generate short description of event
function family_show_short_event ($fid) {
  $events_code = array('BIRT', 'MARR', 'DEAT', 'ADOP', 'BURI', 'EMIG', 'ENGA', 'DIV');
  $events_full = array('BIRT'=>'Born', 'MARR'=>'Married', 'DEAT'=>'Died', 'ADOP'=>'Adopted',
                       'BURI'=>'Burried', 'EMIG'=>'Emigrated', 'ENGA'=>'Engaged', 'DIV'=>'Divorce');
  $fact_code = db_result(db_query("SELECT fact_code FROM {family_facts} WHERE fid = %d", $fid));
  $content=$events_full[$fact_code];
  $seperator=": ";
  $place = db_result(db_query("SELECT f.fact_value FROM {family_facts} f, {family_relations} r ".
          "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", "PLAC",$fid));
  if ($place) {
    $content .= $seperator.$place;
    $seperator=", ";
  }
  $date = db_result(db_query("SELECT f.fact_value FROM {family_facts} f, {family_relations} r ".
          "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", "DATE",$fid));
  if ($date) {
    $content .= $seperator.$date;
  }
  return($content);
}

// Generate summary of individual information
function family_line_indi ($fid) {
  $content="<P>";
  $content .= "<strong>". family_make_name($fid) ."</strong>";
  if ($show_record = family_check_privacy($fid)) {
    $sex = db_result(db_query("SELECT f.fact_value FROM {family_facts} f, {family_relations} r ".
            "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", "SEX",$fid));
    if ($sex) {
      $content .= ", ".$sex;
    }
    $content .= "<br>";
  }
  
//Find parents
  $fam = db_result(db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
          "WHERE (f.fact_code = '%s' AND f.fid=r.fid2 AND r.fid1= %d AND r.relation_description='%s')", "FAM",$fid,"CHIL"));
  if ($fam) {
    $father = db_result(db_query("SELECT fid1 FROM {family_relations} WHERE (fid2 = %d AND relation_description='%s')", $fam, "HUSB"));
    if ($father) {
      $list[] = 'Father: '. family_make_name($father);
    }
    $mother = db_result(db_query("SELECT fid1 FROM {family_relations} WHERE (fid2 = %d AND relation_description='%s')", $fam, "WIFE"));
    if ($mother) {
      $list[] = 'Mother: '. family_make_name($mother);
    }
  }
  if ($show_record) {
    $birth = db_result(db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
            "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", "BIRT",$fid));
    if ($birth) {
      $list[] = family_show_short_event($birth);
    }
    $death = db_result(db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
            "WHERE (f.fact_code = '%s' AND f.fid=r.fid1 AND r.fid2= %d)", "DEAT",$fid));
    if ($death) {
      $list[] = family_show_short_event($death);
    }
  }
  $content .= theme('item_list', $list);
  $content .= "</P>";
  return ($content);
}

// Display family view of individual fid
function family_view_indi($fid) {
  $content="";
  $content .= family_line_indi ($fid);

//Find families where the individual is husband or wife
  $families = db_query("SELECT f.fid FROM {family_facts} f, {family_relations} r ".
          "WHERE (f.fact_code = '%s' AND f.fid=r.fid2 AND r.fid1= %d AND".
          "(r.relation_description='%s' OR r.relation_description='%s'))", "FAM",$fid,"HUSB","WIFE");
  if ($families) {
    $list1 = array();
    for ($j = 0; $j < db_num_rows($families); $j++) {
      $fam=db_result($families,$j);
      $spouse = db_result(db_query("SELECT fid1 FROM {family_relations} WHERE (fid2 = %d AND fid1 <> %d AND (relation_description='%s' OR relation_description='%s'))", $fam, $fid, "HUSB","WIFE"));
      if ($spouse) {
        $parents=TRUE;
        $content .= "<hr><strong>Spouse: </strong>".family_line_indi ($spouse);
      }
      else {
        $content .= "<hr><p><strong>Spouse: </strong>Unknown</p>";
      }
      $children = db_query("SELECT fid1 FROM {family_relations} WHERE (fid2 = %d AND relation_description='%s')", $fam, "CHIL");
      if ($children && (db_num_rows($children)>0)) {
        $content .= 'Children of '. family_make_name($fid).' and '. family_make_name($spouse) .':'. family_indi_list($children);
      }
    }
  }
  return($content);
}

//View family record
function family_view_record($fid = 0) {

  $events_code = array('BIRT', 'MARR', 'DEAT', 'ADOP', 'BURI', 'EMIG', 'ENGA', 'DIV');
  $events_full = array('BIRT'=>'Born', 'MARR'=>'Married', 'DEAT'=>'Died', 'ADOP'=>'Adopted',
                       'BURI'=>'Burried', 'EMIG'=>'Emigrated', 'ENGA'=>'Engaged', 'DIV'=>'Divorce');
  $facts_code = array('OCCU', 'RESI', 'NATI', 'EDUC', 'RELI', 'TITL');
  $facts_full = array('OCCU'=>'Occupation', 'RESI'=>'Residence', 'NATI'=>'Nationalization',
                      'EDUC'=>'Education', 'RELI'=>'Religion', 'TITL'=>'Title');

  if (!is_numeric($fid)) {
    drupal_access_denied();
    return $content;
  } 

// If no parameter has been defined, view individualS list
  if ($fid==0) {
    $content = family_indi_list("ALL");
    return $content;
  }
  $content = '<p>';

  $fact = db_fetch_array(db_query("SELECT fact_code,fact_value FROM {family_facts} WHERE fid = %d", $fid));
  $fact_code=$fact['fact_code'];
  $value=$fact['fact_value'];

  switch (TRUE) {
    case $fact_code=="INDI":
      $content.=family_view_indi($fid);
      break;

    case $fact_code=="FAM":
      $content.="Family view is not supported in this version";
      break;

    case in_array($fact_code, $events_code):
      $content.="Event view is not supported in this version";
      break;

    default:
      $content.="Illegal record number";
      break;
  }
  $content.="</p>";
  return $content;
}


